import os
import sys
import codecs
from win32api import GetFileAttributes

if __name__=="__main__":
    #Open/create the playlist file in UTF-8 for special character support.
    #The m3u8 extension is needed opposed to m3u for Winamp to read UTF-8 correctly.
    f = codecs.open(".\\ZZZall.m3u8", 'w', 'UTF-8')
    hidden = 0
    normal = 0
    #A list of all found valid extensions (example file names), useful for
    #checking if any file types were mistakenly added to the playlist
    extensions = []
    extFiles = []
    for root, dirs, files in os.walk(u'.\\'):
        #specify here all directories that should be excluded from checking (useful if you have
        #some large directory substructures next to your music, e.g. svn repositories :)
        if not (root.endswith("excluded")):
            for name in files:
                lowercase = name.lower()
                #Exclude all extensions of expected file types that should not be in playlist.
                #Alternatively, you could positively check for all valid extensions, like *.mp3,
                #*.flac, *.wav etc. The first way is usually better, since it is less of a problem
                #if you have some false positives in your playlist (they will be automatically
                #skipped) than missing some music that you wanted to include
                if not (lowercase.endswith(".jpg") or lowercase.endswith(".bmp")\
                        or lowercase.endswith(".gif") or lowercase.endswith(".pdf")\
                        or lowercase.endswith(".txt") or lowercase.endswith(".m3u")\
                        or lowercase.endswith(".m3u8") or lowercase.endswith(".sfv")\
                        or lowercase.endswith(".html") or lowercase.endswith(".htm")\
                        or lowercase.endswith(".url")or lowercase.endswith(".py")\
                        or lowercase.endswith(".log") or lowercase.endswith(".nfo")\
                        or lowercase.endswith(".doc") or lowercase.endswith(".crd")\
                        or lowercase.endswith(".1rd") or lowercase.endswith(".sib")\
                        or lowercase.endswith(".mid") or lowercase.endswith(".pls")\
                        or lowercase.endswith(".zip") or lowercase.endswith(".7z")\
                        or lowercase.endswith(".rar") or lowercase.endswith(".js")\
                        or lowercase.endswith(".exe")):
                    #Check extension and possibly expand the extension list
                    if not extensions.__contains__(lowercase[-3:].encode('ascii')):
                        extensions.append(lowercase[-3:].encode('ascii'))
                        extFiles.append(lowercase)
                    f.write(os.path.abspath(root)+"\\"+name+"\n")
    print "Valid extensions: ",extensions
    print "Example extension files:"
    for file in extFiles:
        print file